diff -ruN ccp4srs-old/ccp4srs/ccp4srs_monomer.cpp ccp4srs/ccp4srs/ccp4srs_monomer.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_monomer.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_monomer.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -697,427 +610,557 @@
       return rc;
     }
 
-  }
 
-  // take tree records
-  loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_TREE );
-  readMonIDFromCIF ( loop );
-  rc = struct_tree.readFromCIF ( loop,atoms );
-
-  if (rc)  {
-    reset();
-    return rc;
-  }
+    // take bonds
+    mmCIFLoop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_BOND );
+    if (!mmCIFLoop)
+      mmCIFStruct = mmCIFData->GetStructure ( MMCIF_LOOP_CHEM_COMP_BOND );
+
+    if (mmCIFLoop)  {
+
+      readMonIDFromCIF ( mmCIFLoop );
+
+      loop_len = mmCIFLoop->GetLoopLength();
+      rc       = 0;
+      for (i=0;(i<loop_len) && (!rc);i++)  {
+        bond = new Bond();
+        rc = bond->readFromCIF_rcsb ( mmCIFLoop,i,atoms );
+        if (!rc)  bonds.add ( bond );
+        else  {
+          if (error_desc)
+            sprintf ( error_desc,"Error %i in row %i of %s loop",
+                      rc,i+1,MMCIF_LOOP_CHEM_COMP_BOND );
+          delete bond;
+        }
+      }
 
-  // take bonds
-  loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_BOND );
-  readMonIDFromCIF ( loop );
+    } else if (mmCIFStruct)  {
 
-  if (loop)  {
+      readMonIDFromCIF ( mmCIFStruct );
 
-    loop_len = loop->GetLoopLength();
-    rc       = 0;
-    for (i=0;(i<loop_len) && (!rc);i++)  {
-      bond = new CCP4SRSBond();
-      rc = bond->readFromCIF_ccp4 ( loop,i,atoms );
+      bond = new Bond();
+      rc = bond->readFromCIF ( mmCIFStruct,atoms );
       if (!rc)  bonds.add ( bond );
       else  {
         if (error_desc)
-          sprintf ( error_desc,"Error %i in row %i of %s loop",
-                    rc,i+1,MMCIF_LOOP_CHEM_COMP_BOND );
-        delete bond;
-      }
-      /*
-      if ((!rc) || (rc==CCP4SRS_WrongBondType))  {
-        bonds.add ( bond );
-        rc = 0;
-      } else  {
-        if (error_desc)
-          sprintf ( error_desc,"Error %i in row %i of %s loop",
-                    rc,i+1,MMCIF_LOOP_CHEM_COMP_BOND );
+          sprintf ( error_desc,"Error %i in %s structure",
+                    rc,MMCIF_LOOP_CHEM_COMP_BOND );
         delete bond;
       }
-      */
+
     }
 
+    // take bonds
+    mmCIFLoop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_DESCRIPTOR );
+    if (mmCIFLoop)  {
+      ACDLabs.readFromCIF_rcsb ( mmCIFLoop,"ACDLabs" );
+      CACTVS .readFromCIF_rcsb ( mmCIFLoop,"CACTVS"  );
+      OpenEye.readFromCIF_rcsb ( mmCIFLoop,"OpenEye OEToolkits" );
+      InChI  .readFromCIF_rcsb ( mmCIFLoop,"InChI"   );
+    } else  {
+      ACDLabs.freeSmiles();
+      CACTVS .freeSmiles();
+      OpenEye.freeSmiles();
+      InChI  .freeSmiles();
+    }
+
+/*
+loop_
+_pdbx_chem_comp_descriptor.comp_id
+_pdbx_chem_comp_descriptor.type
+_pdbx_chem_comp_descriptor.program
+_pdbx_chem_comp_descriptor.program_version
+_pdbx_chem_comp_descriptor.descriptor
+000 SMILES           ACDLabs              12.01 "O=C(O)OC"
+000 SMILES_CANONICAL CACTVS               3.370 "COC(O)=O"
+000 SMILES           CACTVS               3.370 "COC(O)=O"
+000 SMILES_CANONICAL "OpenEye OEToolkits" 1.7.0 "COC(=O)O"
+000 SMILES           "OpenEye OEToolkits" 1.7.0 "COC(=O)O"
+000 InChI            InChI                1.03  "InChI=1S/C2H4O3/c1-5-2(3)4/h1H3,(H,3,4)"
+000 InChIKey         InChI                1.03  CXHHBNMLPJOKQD-UHFFFAOYSA-N
+*/
+
     if (rc)  {
       reset();
       return rc;
     }
 
+    return CCP4SRS_Ok;
+
   }
 
-  // take angles
-  loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_ANGLE );
-  readMonIDFromCIF ( loop );
-
-  if (loop)  {
-
-    loop_len = loop->GetLoopLength();
-    rc       = 0;
-    for (i=0;(i<loop_len) && (!rc);i++)  {
-      angle = new CCP4SRSAngle();
-      rc = angle->readFromCIF ( loop,i,atoms );
-      if (!rc)  angles.add ( angle );
-      else  {
-        if (error_desc)
-          sprintf ( error_desc,"Error %i in row %i of %s loop",
-                    rc,i+1,MMCIF_LOOP_CHEM_COMP_ANGLE );
-        delete angle;
+  int Monomer::readFromCIF_ccp4 ( mmdb::mmcif::PData mmCIFData,
+                                  mmdb::pstr error_desc )  {
+  mmdb::mmcif::PLoop loop;
+  PAtom       atom;
+  PBond       bond;
+  PAngle      angle;
+  PChiCenter  chicenter;
+  PTorsion    torsion;
+  PPlane      plane;
+  int                loop_len, i,n, rc;
+
+    // take atoms
+    loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_ATOM );
+    readMonIDFromCIF ( loop );
+
+    if (loop)  {
+
+      loop_len = loop->GetLoopLength();
+      rc       = 0;
+      for (i=0;(i<loop_len) && (!rc);i++)  {
+        atom = new Atom();
+        rc = atom->readFromCIF_ccp4 ( loop,i );
+        if (!rc)  atoms.add ( atom );
+        else  {
+          if (error_desc)
+            sprintf ( error_desc,"Error %i in row %i of %s loop",
+                      rc,i+1,MMCIF_LOOP_CHEM_COMP_ATOM );
+          delete atom;
+        }
+      }
+
+      if (rc)  {
+        reset();
+        return rc;
       }
+
     }
 
+    // take tree records
+    loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_TREE );
+    readMonIDFromCIF ( loop );
+    rc = struct_tree.readFromCIF ( loop,atoms );
+
     if (rc)  {
       reset();
       return rc;
     }
 
-  }
+    // take bonds
+    loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_BOND );
+    readMonIDFromCIF ( loop );
+
+    if (loop)  {
+
+      loop_len = loop->GetLoopLength();
+      rc       = 0;
+      for (i=0;(i<loop_len) && (!rc);i++)  {
+        bond = new Bond();
+        rc = bond->readFromCIF_ccp4 ( loop,i,atoms );
+        if (!rc)  bonds.add ( bond );
+        else  {
+          if (error_desc)
+            sprintf ( error_desc,"Error %i in row %i of %s loop",
+                      rc,i+1,MMCIF_LOOP_CHEM_COMP_BOND );
+          delete bond;
+        }
+        /*
+        if ((!rc) || (rc==_WrongBondType))  {
+          bonds.add ( bond );
+          rc = 0;
+        } else  {
+          if (error_desc)
+            sprintf ( error_desc,"Error %i in row %i of %s loop",
+                      rc,i+1,MMCIF_LOOP_CHEM_COMP_BOND );
+          delete bond;
+        }
+        */
+      }
 
-  // take chiral centers
-  loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_CHIR );
-  readMonIDFromCIF ( loop );
+      if (rc)  {
+        reset();
+        return rc;
+      }
 
-  if (loop)  {
+    }
 
-    // reset atom chirality signs
-    for (i=0;i<atoms.numberOf();i++)
-      atoms.at(i)->set_chirality ( 'N' );
+    // take angles
+    loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_ANGLE );
+    readMonIDFromCIF ( loop );
+
+    if (loop)  {
+
+      loop_len = loop->GetLoopLength();
+      rc       = 0;
+      for (i=0;(i<loop_len) && (!rc);i++)  {
+        angle = new Angle();
+        rc = angle->readFromCIF ( loop,i,atoms );
+        if (!rc)  angles.add ( angle );
+        else  {
+          if (error_desc)
+            sprintf ( error_desc,"Error %i in row %i of %s loop",
+                      rc,i+1,MMCIF_LOOP_CHEM_COMP_ANGLE );
+          delete angle;
+        }
+      }
 
-    loop_len = loop->GetLoopLength();
-    rc       = 0;
-    for (i=0;(i<loop_len) && (!rc);i++)  {
-      chicenter = new CCP4SRSChiCenter();
-      rc = chicenter->readFromCIF ( loop,i,atoms );
-      if (!rc)  {
-        chicenters.add ( chicenter );
-        atoms.at(chicenter->center())->set_chirality (
-                                          chicenter->get_chirality() );
-      } else  {
-        if (error_desc)
-          sprintf ( error_desc,"Error %i in row %i of %s loop",
-                    rc,i+1,MMCIF_LOOP_CHEM_COMP_CHIR );
-        delete chicenter;
+      if (rc)  {
+        reset();
+        return rc;
       }
+
     }
 
-    if (rc)  {
-      reset();
-      return rc;
+    // take chiral centers
+    loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_CHIR );
+    readMonIDFromCIF ( loop );
+
+    if (loop)  {
+
+      // reset atom chirality signs
+      for (i=0;i<atoms.numberOf();i++)
+        atoms.at(i)->set_chirality ( 'N' );
+
+      loop_len = loop->GetLoopLength();
+      rc       = 0;
+      for (i=0;(i<loop_len) && (!rc);i++)  {
+        chicenter = new ChiCenter();
+        rc = chicenter->readFromCIF ( loop,i,atoms );
+        if (!rc)  {
+          chicenters.add ( chicenter );
+          atoms.at(chicenter->center())->set_chirality (
+                                            chicenter->get_chirality() );
+        } else  {
+          if (error_desc)
+            sprintf ( error_desc,"Error %i in row %i of %s loop",
+                      rc,i+1,MMCIF_LOOP_CHEM_COMP_CHIR );
+          delete chicenter;
+        }
+      }
+
+      if (rc)  {
+        reset();
+        return rc;
+      }
+
     }
 
-  }
 
+    // take torsions
+    loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_TOR );
+    readMonIDFromCIF ( loop );
+
+    if (loop)  {
+
+      loop_len = loop->GetLoopLength();
+      rc       = 0;
+      for (i=0;(i<loop_len) && (!rc);i++)  {
+        torsion = new Torsion();
+        rc = torsion->readFromCIF ( loop,i,atoms );
+        if (!rc)  torsions.add ( torsion );
+        else  {
+          if (error_desc)
+            sprintf ( error_desc,"Error %i in row %i of %s loop",
+                      rc,i+1,MMCIF_LOOP_CHEM_COMP_TOR );
+          delete torsion;
+        }
+      }
 
-  // take torsions
-  loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_TOR );
-  readMonIDFromCIF ( loop );
-
-  if (loop)  {
-
-    loop_len = loop->GetLoopLength();
-    rc       = 0;
-    for (i=0;(i<loop_len) && (!rc);i++)  {
-      torsion = new CCP4SRSTorsion();
-      rc = torsion->readFromCIF ( loop,i,atoms );
-      if (!rc)  torsions.add ( torsion );
-      else  {
-        if (error_desc)
-          sprintf ( error_desc,"Error %i in row %i of %s loop",
-                    rc,i+1,MMCIF_LOOP_CHEM_COMP_TOR );
-        delete torsion;
+      if (rc)  {
+        reset();
+        return rc;
       }
-    }
 
-    if (rc)  {
-      reset();
-      return rc;
     }
 
-  }
 
+    // take planes
+    loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_PLANE_ATOM );
+    readMonIDFromCIF ( loop );
+
+    if (loop)  {
+
+      n  = 0;
+      rc = Plane::Ok;
+      while (rc==Plane::Ok)  {
+        plane = new Plane();
+        rc = plane->readFromCIF ( loop,n,atoms );
+        if (rc==Plane::Ok)  {
+          planes.add ( plane );
+          n++;
+        } else  {
+          if (error_desc && (rc!=Plane::NoMorePlanes))
+            sprintf ( error_desc,"Error %i in plane %s of %s loop",
+                      rc,plane->id(),MMCIF_LOOP_CHEM_COMP_PLANE_ATOM );
+          delete plane;
+        }
+      }
 
-  // take planes
-  loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_PLANE_ATOM );
-  readMonIDFromCIF ( loop );
-
-  if (loop)  {
-
-    n  = 0;
-    rc = CCP4SRSPlane::Ok;
-    while (rc==CCP4SRSPlane::Ok)  {
-      plane = new CCP4SRSPlane();
-      rc = plane->readFromCIF ( loop,n,atoms );
-      if (rc==CCP4SRSPlane::Ok)  {
-        planes.add ( plane );
-        n++;
-      } else  {
-        if (error_desc && (rc!=CCP4SRSPlane::NoMorePlanes))
-          sprintf ( error_desc,"Error %i in plane %s of %s loop",
-                    rc,plane->id(),MMCIF_LOOP_CHEM_COMP_PLANE_ATOM );
-        delete plane;
+      if (rc!=Plane::NoMorePlanes)  {
+        reset();
+        return rc;
       }
-    }
 
-    if (rc!=CCP4SRSPlane::NoMorePlanes)  {
-      reset();
-      return rc;
     }
 
+    return CCP4SRS_Ok;
+
   }
 
-  return CCP4SRS_Ok;
 
-}
+  mmdb::mmcif::PData Monomer::makeCIF()  {
+  mmdb::mmcif::PData data;
+  mmdb::mmcif::PLoop loop;
+  char        S[100];
+  int         i;
 
+    strcpy ( S,MMCIF_COMP );
+    strcat ( S,monID );
+    data = new mmdb::mmcif::Data ( S );
 
-PCMMCIFData CCP4SRSMonomer::makeCIF()  {
-PCMMCIFData data;
-PCMMCIFLoop loop;
-char        S[100];
-int         i;
-
-  strcpy ( S,MMCIF_COMP );
-  strcat ( S,monID );
-  data = new CMMCIFData ( S );
-
-  data->AddLoop ( MMCIF_LOOP_CHEM_COMP_ATOM,loop );
-  CCP4SRSAtom::makeCIFTags ( loop );
-  for (i=0;i<atoms.numberOf();i++)
-    atoms.at(i)->writeToCIF ( loop,monID );
-
-  struct_tree.writeToCIF ( data,monID,atoms );
-
-  data->AddLoop ( MMCIF_LOOP_CHEM_COMP_BOND,loop );
-  CCP4SRSBond::makeCIFTags ( loop );
-  for (i=0;i<bonds.numberOf();i++)
-    bonds.at(i)->writeToCIF ( loop,monID,atoms );
-
-  data->AddLoop ( MMCIF_LOOP_CHEM_COMP_ANGLE,loop );
-  CCP4SRSAngle::makeCIFTags ( loop );
-  for (i=0;i<angles.numberOf();i++)
-    angles.at(i)->writeToCIF ( loop,monID,atoms );
-
-  data->AddLoop ( MMCIF_LOOP_CHEM_COMP_CHIR,loop );
-  CCP4SRSChiCenter::makeCIFTags ( loop );
-  for (i=0;i<chicenters.numberOf();i++)
-    chicenters.at(i)->writeToCIF ( loop,monID,atoms );
-
-  data->AddLoop ( MMCIF_LOOP_CHEM_COMP_TOR,loop );
-  CCP4SRSTorsion::makeCIFTags ( loop );
-  for (i=0;i<torsions.numberOf();i++)
-    torsions.at(i)->writeToCIF ( loop,monID,atoms );
-
-  data->AddLoop ( MMCIF_LOOP_CHEM_COMP_PLANE_ATOM,loop );
-  CCP4SRSPlane::makeCIFTags ( loop );
-  for (i=0;i<planes.numberOf();i++)
-    planes.at(i)->writeToCIF ( loop,monID,atoms );
-
-  return data;
-
-}
-
-void CCP4SRSMonomer::write_mem ( PCMemIO memIO, int version )  {
-  memIO->put_line   ( monID      );
-  memIO->put_line   ( oldMonID   );
-  memIO->put_string ( monName    );
-  memIO->put_string ( monType    );
-  memIO->put_string ( monFormula );
-  atoms      .write_mem ( memIO,version );
-  bonds      .write_mem ( memIO,version );
-  angles     .write_mem ( memIO,version );
-  torsions   .write_mem ( memIO,version );
-  chicenters .write_mem ( memIO,version );
-  planes     .write_mem ( memIO,version );
-  struct_tree.write_mem ( memIO,version );
-}
-
-Boolean CCP4SRSMonomer::read_mem ( PCMemIO memIO, int version,
-                                   Boolean * Ok )  {
-Boolean success;
-  if (Ok)  success = *Ok;
-     else  success = True;
-  memIO->get_line   ( monID     ,&success );
-  memIO->get_line   ( oldMonID  ,&success );
-  memIO->get_string ( monName   ,&success );
-  memIO->get_string ( monType   ,&success );
-  memIO->get_string ( monFormula,&success );
-  atoms      .read_mem ( memIO,version,&success );
-  bonds      .read_mem ( memIO,version,&success );
-  angles     .read_mem ( memIO,version,&success );
-  torsions   .read_mem ( memIO,version,&success );
-  chicenters .read_mem ( memIO,version,&success );
-  planes     .read_mem ( memIO,version,&success );
-  struct_tree.read_mem ( memIO,version,&success );
-  if (Ok)  *Ok = success;
-  return success;
-}
-
-
-int makeElementType ( int ElType, char chirality )  {
-  if (chirality=='S')  return ElType | CHIRAL_LEFT;
-  if (chirality=='R')  return ElType | CHIRAL_RIGHT;
-  return ElType;
-}
-
-
-PCGraph CCP4SRSMonomer::getGraph ( int *retCode )  {
-// Generate chemical graph
-PCGraph      graph;
-PCVertex     vertex;
-PCEdge       edge;
-PCCP4SRSAtom a;
-PCCP4SRSBond b;
-int          i,n,rc,vtype,vx1,vx2;
-
-  graph = new CGraph();
-  graph->SetName ( ID() );
-  rc = 0;
-
-  n = n_atoms();
-  for (i=0;(i<n) && (!rc);i++)  {
-
-    a = atom(i);
-
-    vtype = getElementNo ( a->element() );
-    if (vtype!=ELEMENT_UNKNOWN)  {
-
-      if (a->leaving()=='Y')
-        vtype |= ATOM_LEAVING;
-
-      vertex = new CVertex ( makeElementType(vtype,a->chirality()) );
-      vertex->SetName   ( a->name() );
-      vertex->SetUserID ( i );
-      graph->AddVertex  ( vertex );
-
-    } else
-      rc = 10000 + i;
-
-  }
-
-  n = n_bonds();
-  for (i=0;(i<n) && (!rc);i++)  {
-
-    b   = bond(i);
-    vx1 = b->atom1();
-    vx2 = b->atom2();
-
-    if (vx1<0)  rc = 20000 + i;
-    if (vx2<0)  rc = 30000 + i;
-
-    vx1++;
-    vx2++;
-
-    if (!rc)  {
-      edge = new CEdge ( vx1,vx2,b->order() );
-      graph->AddEdge ( edge );
-    }
-
-  }
-
-  if (rc)  {
-    delete graph;
-    graph = NULL;
-  }
-
-  if (retCode)  *retCode = rc;
-
-  return graph;
-
-}
-
-// service function, assume merging rcsb monomer with monlib one
-void CCP4SRSMonomer::merge ( PCCP4SRSMonomer monomer )  {
-PCCP4SRSAtom                   tatom;
-PCCP4SRSBond                   mbond,tbond;
-PCCP4SRSAngle                  angle;
-PCCP4SRSPlane                  plane;
-PCCP4SRSTorsion                torsion;
-PCCP4SRSChiCenter              chicenter;
-CCP4SRSContainer<CCP4SRSAtom> *matoms;
-AtomName                       aname;
-ivector                        anmatch;
-int                            i,j,k;
-
-  if (!monID[0])  strcpy ( monID,monomer->ID() );
-  else if (strcmp(monID,monomer->ID()))
-    return;  // can't merge dufferent monomers
-
-  if (!oldMonID[0])  strcpy ( oldMonID,monomer->oldID() );
-
-  if (!chem_name()[0])  CreateCopy ( monName,monomer->chem_name() );
-  if (!chem_type()[0])  CreateCopy ( monType,monomer->chem_type() );
-  if (!chem_formula()[0])
-                  CreateCopy ( monFormula,monomer->chem_formula() );
+    data->AddLoop ( MMCIF_LOOP_CHEM_COMP_ATOM,loop );
+    Atom::makeCIFTags ( loop );
+    for (i=0;i<atoms.numberOf();i++)
+      atoms.at(i)->writeToCIF ( loop,monID );
 
-  for (i=0;i<monomer->n_atoms();i++)  {
-    k = -1;
-    strcpy ( aname,monomer->atom(i)->id() );
-    for (j=0;(j<atoms.numberOf()) && (k<0);j++)
-      if (!strcmp(atoms.at(j)->id(),aname))
-        k = j;
-    if (k<0)  {
-      tatom = new CCP4SRSAtom();
-      tatom->copy ( monomer->atom(i) );
-      add ( tatom );
-    } else
-      atoms.at(k)->merge ( monomer->atom(i) );
-  }
+    struct_tree.writeToCIF ( data,monID,atoms );
 
-  GetVectorMemory ( anmatch,monomer->n_atoms(),0 );
-  getAtomNameMatch ( monomer->get_atoms(),anmatch );
+    data->AddLoop ( MMCIF_LOOP_CHEM_COMP_BOND,loop );
+    Bond::makeCIFTags ( loop );
+    for (i=0;i<bonds.numberOf();i++)
+      bonds.at(i)->writeToCIF ( loop,monID,atoms );
+
+    data->AddLoop ( MMCIF_LOOP_CHEM_COMP_ANGLE,loop );
+    Angle::makeCIFTags ( loop );
+    for (i=0;i<angles.numberOf();i++)
+      angles.at(i)->writeToCIF ( loop,monID,atoms );
+
+    data->AddLoop ( MMCIF_LOOP_CHEM_COMP_CHIR,loop );
+    ChiCenter::makeCIFTags ( loop );
+    for (i=0;i<chicenters.numberOf();i++)
+      chicenters.at(i)->writeToCIF ( loop,monID,atoms );
+
+    data->AddLoop ( MMCIF_LOOP_CHEM_COMP_TOR,loop );
+    Torsion::makeCIFTags ( loop );
+    for (i=0;i<torsions.numberOf();i++)
+      torsions.at(i)->writeToCIF ( loop,monID,atoms );
+
+    data->AddLoop ( MMCIF_LOOP_CHEM_COMP_PLANE_ATOM,loop );
+    Plane::makeCIFTags ( loop );
+    for (i=0;i<planes.numberOf();i++)
+      planes.at(i)->writeToCIF ( loop,monID,atoms );
+
+    return data;
+
+  }
+
+  void Monomer::write_mem ( PMemIO memIO, int version )  {
+    memIO->put_line   ( monID      );
+    memIO->put_line   ( oldMonID   );
+    memIO->put_string ( monName    );
+    memIO->put_string ( monType    );
+    memIO->put_string ( monFormula );
+    atoms      .write_mem ( memIO,version );
+    bonds      .write_mem ( memIO,version );
+    angles     .write_mem ( memIO,version );
+    torsions   .write_mem ( memIO,version );
+    chicenters .write_mem ( memIO,version );
+    planes     .write_mem ( memIO,version );
+    struct_tree.write_mem ( memIO,version );
+    ACDLabs    .write_mem ( memIO,version );
+    CACTVS     .write_mem ( memIO,version );
+    OpenEye    .write_mem ( memIO,version );
+    InChI      .write_mem ( memIO,version );
+  }
+
+  bool Monomer::read_mem ( PMemIO memIO, int version, bool * Ok )  {
+  bool success;
+    if (Ok)  success = *Ok;
+       else  success = true;
+    memIO->get_line   ( monID     ,&success );
+    memIO->get_line   ( oldMonID  ,&success );
+    memIO->get_string ( monName   ,&success );
+    memIO->get_string ( monType   ,&success );
+    memIO->get_string ( monFormula,&success );
+    atoms      .read_mem ( memIO,version,&success );
+    bonds      .read_mem ( memIO,version,&success );
+    angles     .read_mem ( memIO,version,&success );
+    torsions   .read_mem ( memIO,version,&success );
+    chicenters .read_mem ( memIO,version,&success );
+    planes     .read_mem ( memIO,version,&success );
+    struct_tree.read_mem ( memIO,version,&success );
+    ACDLabs    .read_mem ( memIO,version,&success );
+    CACTVS     .read_mem ( memIO,version,&success );
+    OpenEye    .read_mem ( memIO,version,&success );
+    InChI      .read_mem ( memIO,version,&success );
+
+    if (Ok)  *Ok = success;
+    return success;
+  }
+
+
+  int makeElementType ( int ElType, char chirality )  {
+    if (chirality=='S')  return ElType | mmdb::math::CHIRAL_LEFT;
+    if (chirality=='R')  return ElType | mmdb::math::CHIRAL_RIGHT;
+    return ElType;
+  }
+
+
+  mmdb::math::PGraph Monomer::getGraph ( int *retCode )  {
+  // Generate chemical graph
+  mmdb::math::PGraph  graph;
+  mmdb::math::PVertex vertex;
+  mmdb::math::PEdge   edge;
+  PAtom        a;
+  PBond        b;
+  int                 i,n,rc,vtype,vx1,vx2;
+
+    graph = new mmdb::math::Graph();
+    graph->SetName ( ID() );
+    rc = 0;
+
+    n = n_atoms();
+    for (i=0;(i<n) && (!rc);i++)  {
+
+      a = atom(i);
+
+      vtype = mmdb::getElementNo ( a->element() );
+      if (vtype!=mmdb::ELEMENT_UNKNOWN)  {
+
+        if (a->leaving()=='Y')
+          vtype |= mmdb::math::ATOM_LEAVING;
+
+        vertex = new mmdb::math::Vertex (
+                     makeElementType(vtype,a->chirality()) );
+        vertex->SetName   ( a->name() );
+        vertex->SetUserID ( i );
+        graph->AddVertex  ( vertex );
+
+      } else
+        rc = 10000 + i;
+
+    }
+
+    n = n_bonds();
+    for (i=0;(i<n) && (!rc);i++)  {
+
+      b   = bond(i);
+      vx1 = b->atom1();
+      vx2 = b->atom2();
 
-  matoms = monomer->get_atoms();
-  for (i=0;i<monomer->n_bonds();i++)  {
-    k     = -1;
-    mbond = monomer->bond(i);
-    for (j=0;(j<bonds.numberOf()) && (k<0);j++)
-      if (mbond->compare(*matoms,bonds.at(j),atoms))
-        k = j;
-    if (k<0)  {
-      tbond = new CCP4SRSBond();
-      if (tbond->copy(atoms,mbond,*matoms))
-            bonds.add ( tbond );
-      else  delete tbond;
-    } else if (bonds.at(k)->length()<=1.0e-10)
-      bonds.at(k)->copy ( mbond,anmatch );
-  }
+      if (vx1<0)  rc = 20000 + i;
+      if (vx2<0)  rc = 30000 + i;
+
+      vx1++;
+      vx2++;
+
+      if (!rc)  {
+        edge = new mmdb::math::Edge ( vx1,vx2,b->order() );
+        graph->AddEdge ( edge );
+      }
 
-  if (angles.numberOf()<=0)  {
-    for (i=0;i<monomer->n_angles();i++)  {
-      angle = new CCP4SRSAngle();
-      angle->copy ( monomer->angle(i),anmatch );
-      angles.add ( angle );
     }
-  }
 
-  if (torsions.numberOf()<=0)  {
-    for (i=0;i<monomer->n_torsions();i++)  {
-      torsion = new CCP4SRSTorsion();
-      torsion->copy ( monomer->torsion(i),anmatch );
-      torsions.add ( torsion );
+    if (rc)  {
+      delete graph;
+      graph = NULL;
     }
+
+    if (retCode)  *retCode = rc;
+
+    return graph;
+
   }
 
-  if (chicenters.numberOf()<=0)  {
-    for (i=0;i<monomer->n_chicenters();i++)  {
-      chicenter = new CCP4SRSChiCenter();
-      chicenter->copy ( monomer->chicenter(i),anmatch );
-      chicenters.add ( chicenter );
+  // service function, assume merging rcsb monomer with monlib one
+  void Monomer::merge ( PMonomer monomer )  {
+  PAtom            tatom;
+  PBond            mbond,tbond;
+  PAngle           angle;
+  PPlane           plane;
+  PTorsion         torsion;
+  PChiCenter       chicenter;
+  Container<Atom> *matoms;
+  mmdb::AtomName   aname;
+  mmdb::ivector    anmatch;
+  int              i,j,k;
+
+    if (!monID[0])  strcpy ( monID,monomer->ID() );
+    else if (strcmp(monID,monomer->ID()))
+      return;  // can't merge dufferent monomers
+
+    if (!oldMonID[0])  strcpy ( oldMonID,monomer->oldID() );
+
+    if (!chem_name()[0])  mmdb::CreateCopy ( monName,monomer->chem_name() );
+    if (!chem_type()[0])  mmdb::CreateCopy ( monType,monomer->chem_type() );
+    if (!chem_formula()[0])
+                    mmdb::CreateCopy ( monFormula,monomer->chem_formula() );
+    if (ACDLabs.isEmpty())  ACDLabs.copy ( monomer->getACDLabs() );
+    if (CACTVS .isEmpty())  CACTVS .copy ( monomer->getCACTVS () );
+    if (OpenEye.isEmpty())  OpenEye.copy ( monomer->getOpenEye() );
+    if (InChI  .isEmpty())  InChI  .copy ( monomer->getInChI  () );
+
+    for (i=0;i<monomer->n_atoms();i++)  {
+      k = -1;
+      strcpy ( aname,monomer->atom(i)->id() );
+      for (j=0;(j<atoms.numberOf()) && (k<0);j++)
+        if (!strcmp(atoms.at(j)->id(),aname))
+          k = j;
+      if (k<0)  {
+        tatom = new Atom();
+        tatom->copy ( monomer->atom(i) );
+        add ( tatom );
+      } else
+        atoms.at(k)->merge ( monomer->atom(i) );
+    }
+
+    mmdb::GetVectorMemory ( anmatch,monomer->n_atoms(),0 );
+    getAtomNameMatch ( monomer->get_atoms(),anmatch );
+
+    matoms = monomer->get_atoms();
+    for (i=0;i<monomer->n_bonds();i++)  {
+      k     = -1;
+      mbond = monomer->bond(i);
+      for (j=0;(j<bonds.numberOf()) && (k<0);j++)
+        if (mbond->compare(*matoms,bonds.at(j),atoms))
+          k = j;
+      if (k<0)  {
+        tbond = new Bond();
+        if (tbond->copy(atoms,mbond,*matoms))
+              bonds.add ( tbond );
+        else  delete tbond;
+      } else if (bonds.at(k)->length()<=1.0e-10)
+        bonds.at(k)->copy ( mbond,anmatch );
+    }
+
+    if (angles.numberOf()<=0)  {
+      for (i=0;i<monomer->n_angles();i++)  {
+        angle = new Angle();
+        angle->copy ( monomer->angle(i),anmatch );
+        angles.add ( angle );
+      }
     }
-  }
 
-  if (planes.numberOf()<=0)  {
-    for (i=0;i<monomer->n_planes();i++)  {
-      plane = new CCP4SRSPlane();
-      plane->copy ( monomer->plane(i),anmatch );
-      planes.add ( plane );
+    if (torsions.numberOf()<=0)  {
+      for (i=0;i<monomer->n_torsions();i++)  {
+        torsion = new Torsion();
+        torsion->copy ( monomer->torsion(i),anmatch );
+        torsions.add ( torsion );
+      }
+    }
+
+    if (chicenters.numberOf()<=0)  {
+      for (i=0;i<monomer->n_chicenters();i++)  {
+        chicenter = new ChiCenter();
+        chicenter->copy ( monomer->chicenter(i),anmatch );
+        chicenters.add ( chicenter );
+      }
     }
-  }
 
-  if (struct_tree.size()<=0)
-    struct_tree.copy ( monomer->tree(),anmatch );
+    if (planes.numberOf()<=0)  {
+      for (i=0;i<monomer->n_planes();i++)  {
+        plane = new Plane();
+        plane->copy ( monomer->plane(i),anmatch );
+        planes.add ( plane );
+      }
+    }
 
-  FreeVectorMemory ( anmatch,0 );
+    if (struct_tree.size()<=0)
+      struct_tree.copy ( monomer->tree(),anmatch );
+
+    mmdb::FreeVectorMemory ( anmatch,0 );
+
+  }
 
-}
+}  // namespace
